//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                                                             s-PSI@FuturePrice.mq4 |
//|                                       Copyright  2011, Igor Stepovoi aka TarasBY |
//|                                                                taras_bulba@tut.by |
//|    : F=A*O^a1*H^a2*L^a3*C^a4                                 |
//|  - A,a1,a2,a3,a4 -  ,        |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
#property copyright "Copyright  2012, TarasBY"
#property link      "taras_bulba@tut.by"
#property show_inputs
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  *****                  *****                     |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
extern int   BeginBar                 = 10;                //     
//IIIIIIIIIIIIIIIIIIII======  =======IIIIIIIIIIIIIIIIIIIIII+
double       gd_Koef = 1.0531049,
             gda_Koef[] = {0.27950,0.04371,-0.70935,1.17477};
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|               Custom script iteration function                                    |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int start()
{
    string ls_NameGV = "FP_";
//----
    
    fObjectsDeleteAll (ls_NameGV, 0);
    for (int li_Bar = BeginBar; li_Bar >= 1; li_Bar--)
    {
        double ld_Price = fFuturePrice (gd_Koef, gda_Koef, Symbol(), Period(), li_Bar);
        Print ("Price[", TimeToStr (Time[li_Bar-1]), "] = ", ld_Price);
        fSet_Arrow (ls_NameGV + TimeToStr (Time[li_Bar-1]), 6, "", 1, Gold, Time[li_Bar-1], ld_Price, 0);
    }
//----
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|           fi_Bar                             |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double fFuturePrice (double fd_Koef,     //  
                     double ar_Koef[],   //  
                     string fs_Symbol,
                     int fi_TF,
                     int fi_Bar = 1)
{
    double ld_Price = fd_Koef;
    int    lia_IND[] = {1,2,3,0}; //      
//----
    for (int li_PR = 0; li_PR < 4; li_PR++)
    {ld_Price *= MathPow (fGet_PriceOnBar (lia_IND[li_PR], fs_Symbol, fi_TF, fi_Bar), ar_Koef[li_PR]);}
//----
    return (ld_Price);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|           fi_Bar                             |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double fGet_PriceOnBar (int fi_VariantPrice,    //  
                        string fs_Symbol,       // Symbol
                        int fi_TF,              // 
                        int fi_Bar = 1)         // 
{
    double ld_Price = 0.0;
//----
    switch (fi_VariantPrice)
    {
        case 0:
            if (fs_Symbol == Symbol()) if (fi_TF == Period()) {ld_Price = Close[fi_Bar]; break;}
            ld_Price = iClose (fs_Symbol, fi_TF, fi_Bar);
            break;
        case 1:
            if (fs_Symbol == Symbol()) if (fi_TF == Period()) {ld_Price = Open[fi_Bar]; break;}
            ld_Price = iOpen (fs_Symbol, fi_TF, fi_Bar);
            break;
        case 2:
            if (fs_Symbol == Symbol()) if (fi_TF == Period()) {ld_Price = High[fi_Bar]; break;}
            ld_Price = iHigh (fs_Symbol, fi_TF, fi_Bar);
            break;
        case 3:
            if (fs_Symbol == Symbol()) if (fi_TF == Period()) {ld_Price = Low[fi_Bar]; break;}
            ld_Price = iLow (fs_Symbol, fi_TF, fi_Bar);
            break;
        case 4: //  , (high+low)/2
            if (fs_Symbol == Symbol()) if (fi_TF == Period())
            {ld_Price = (High[fi_Bar] + Low[fi_Bar]) / 2; break;}
            ld_Price = (iHigh (fs_Symbol, fi_TF, fi_Bar) + iLow (fs_Symbol, fi_TF, fi_Bar)) / 2;
            break;
        case 5: //  , (high+low+close)/3
            if (fs_Symbol == Symbol()) if (fi_TF == Period())
            {ld_Price = (High[fi_Bar] + Low[fi_Bar] + Close[fi_Bar]) / 3; break;}
            ld_Price = (iHigh (fs_Symbol, fi_TF, fi_Bar) + iLow (fs_Symbol, fi_TF, fi_Bar) + iClose (fs_Symbol, fi_TF, fi_Bar)) / 3;
            break;
        case 6: //   , (high+low+close+close)/4
            if (fs_Symbol == Symbol()) if (fi_TF == Period())
            {ld_Price = (High[fi_Bar] + Low[fi_Bar] + 2 * Close[fi_Bar]) / 4; break;}
            ld_Price = (iHigh (fs_Symbol, fi_TF, fi_Bar) + iLow (fs_Symbol, fi_TF, fi_Bar) + 2 * iClose (fs_Symbol, fi_TF, fi_Bar)) / 4;
            break;
    }
//----
    return (ld_Price);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|      : TarasBY, taras_bulba@tut.by                                           |
//+-----------------------------------------------------------------------------------+
//|     : 23.07.2011                                                            |
//|   :   OBJ_ARROW                                           |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool fSet_Arrow (string fs_Name,         //  
                 int fi_ArrowCode,       //    OBJ_ARROW
                 string fs_Description,  //  
                 int fi_Size = 0,        //  
                 color fc_Color = Gold,  // 
                 datetime fdt_Time = 0,  //  
                 double fd_Price = 0,    //  
                 int fi_Window = 0)      //  
{
	 int err = GetLastError();
//----
    //fSet_Arrow (ls_Name, 218, "", 2, Gold, Time[0], Bid, 0);
    if (fs_Name == "") fs_Name = TimeToStr (Time[0]);
    if (!fObjectFind (fs_Name)) {if (!ObjectCreate (fs_Name, OBJ_ARROW, fi_Window, 0, 0)) return (false);}
    if (fdt_Time == 0) {fdt_Time = Time[0];}
    if (fd_Price == 0) {fd_Price = Bid;}
    ObjectSet (fs_Name, OBJPROP_TIME1, fdt_Time);
    ObjectSet (fs_Name, OBJPROP_PRICE1, fd_Price);
    ObjectSet (fs_Name, OBJPROP_ARROWCODE, fi_ArrowCode);
    if (fs_Description != "") ObjectSetText (fs_Name, fs_Description, 10, "Calibri", fc_Color);
    ObjectSet (fs_Name, OBJPROP_COLOR, fc_Color);
    ObjectSet (fs_Name, OBJPROP_WIDTH, fi_Size);
    //----   
    //fGet_LastError (bs_Error, "fSet_Arrow()");
//----
    return (true);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                       |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool fObjectFind (string fs_Name)
{
    if (StringLen (fs_Name) == 0) {return (false);}
    if (ObjectFind (fs_Name) != -1) {return (true);}
//----
    string ls_Name = "";
    int err = GetLastError();
//----
    for (int i = ObjectsTotal() - 1; i >= 0; i--)
    {
        ls_Name = ObjectName (i);
        if (ls_Name == fs_Name) {return (true);}
    }
    //----   
    //fGet_LastError (bs_Error, StringConcatenate ("fObjectFind(): Find (", fs_Name, ")"));
//----
    return (false);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                  |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fObjectsDeleteAll  (string fs_Pref = "",     //   
                         int fi_Window = -1,      //  
                         int ti_Type = -1)        //  
                         
{
    string ls_Name; 
//----
	 for (int li_OBJ = ObjectsTotal() - 1; li_OBJ >= 0; li_OBJ--)
	 {
        ls_Name = ObjectName (li_OBJ);
        //----  " " 
        if (fi_Window >= 0) {if (ObjectFind (ls_Name) != fi_Window) continue;}
        //----  " "  
		  if (ti_Type >= 0) {if (ObjectType (ls_Name) != ti_Type) continue;}
		  if (fs_Pref != "") {if (StringFind (ls_Name, fs_Pref) != 0) continue;}
		  ObjectDelete (ls_Name);
	 }
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+

